/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :
* Device(s)    : BAT32G139
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2022/5/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "uart_demo.h"
#include "tim_demo.h"
#include "delay_demo.h"
#include "dma_demo.h"
#include "lin_protocol.h"

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
uint8_t lin_tx_buf[9];
static uint8_t lin_rx_flag;

//ʱλΪtick
void systick_delay(uint32_t time)
{
	volatile uint32_t tick_old, tick_new;
	tick_old = SysTick->VAL;
	while(1)
	{
		tick_new = SysTick->VAL;
		if(tick_old > tick_new)
		{
			if(tick_old - tick_new > time)
			{
				break;
			}
		}
		else if(tick_old + SysTick->LOAD - tick_new > time)
		{
			break;
		}
	}
}

int main()
{
    uint32_t msCnt, i; // count value of 1ms
    //-----------------------------------------------------------------------
    // Systick setting
    //-----------------------------------------------------------------------
    SystemCoreClockUpdate();
    msCnt = SystemCoreClock / 1000;
    SysTick_Config(msCnt);
    delay_init(SystemCoreClock); //ʱʼ

	txFrame.PID = (uint8_t)0xF0;
	txFrame.Data[0] = (uint8_t)0x00;
	txFrame.Data[1] = (uint8_t)0x01;
	txFrame.Data[2] = (uint8_t)0x02;
	txFrame.Data[3] = (uint8_t)0x03;
	txFrame.Data[4] = (uint8_t)0x10;
	txFrame.Data[5] = (uint8_t)0x20;
	txFrame.Data[6] = (uint8_t)0x30;
	txFrame.Data[7] = (uint8_t)0x40;
	for(i=0; i<8; i++)
	{
		txFrame.ChkSum  ^= txFrame.Data[i];
	}
	
	LIN_SleepIO_Init();
	LIN_SLEEP_LOW;
	LIN_SetConfig();
	LIN_SLEEP_HIGH; //߽	
	lin_state = IDLE;
	
	while(1)
	{

		switch(lin_state)
		{
			case IDLE:
			case WAKE:
				LIN_ReceiveBreak();
				break_timeout = 0;
				lin_check_timeout	= 0;
				lin_state = BREAK;
				break;
			case BREAK:
				if(lin_check_timeout)
				{
					if(break_timeout ++ > 50000)
					{
						lin_state = IDLE;
					}
					systick_delay(48);
				}
				break;
			case LIN_RX:
				if(g_uart_rx_end == 1)
				{
					g_uart_rx_end = 0;
					lin_state = IDLE;
					lin_rx_flag = 1;
				}
				//ʱ
				if(rx_timeout++ > 50000)
				{
					lin_state = IDLE;
				}
				
				break;
			case LIN_TX:
				//Ҫ͵ݿλ
				lin_tx_buf[0] = 0xaa;//TM40->TDR01 &0xFF;
				lin_tx_buf[1] = TM40->TDR01 >>8;
				lin_tx_buf[2] = TM40->TDR02 &0xFF;
				lin_tx_buf[3] = TM40->TDR02 >>8;
				lin_tx_buf[4] = TM40->TDR03 &0xFF;
				lin_tx_buf[5] = TM40->TDR03 >>8;
				lin_tx_buf[8] = Lin_Checksum(0x06, &lin_tx_buf[0]);
				while(g_uart_tx_end == 0)
				{
				}
				lin_state = IDLE;
				break;
		}
		
		if(lin_rx_flag)
		{
			lin_rx_flag = 0;
			if(rxFrame.PID_b.ID == 0x3C &&rxFrame.Data[0] == 0x7F && rxFrame.Data[5] == 0x01)
			{

			}
			if(rxFrame.PID_b.ID == 0x3C &&rxFrame.Data[0] == 0x7F && rxFrame.Data[5] == 0x04)
			{

			}
			if(rxFrame.PID_b.ID == 0x05)
			{
			}
		}
	}	
}




