/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :  
* Device(s)    : BAT32G139
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2019/4/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "gpio_demo.h"
#include "uart_demo.h"
#include "timm_demo.h"

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/


int main()
{
	uint32_t msCnt; 	// count value of 1ms
	uint32_t width, period;
//-----------------------------------------------------------------------
// Systick setting 
//-----------------------------------------------------------------------   

	SystemCoreClockUpdate();
	msCnt = SystemCoreClock / 1000;
	SysTick_Config(msCnt); 
	
	Uart0_Init(19200);

	/*ʵʱ/*/
	TMM0_Get_PulseWidth_Init(TMM_FCLK_Div1, TMM_Capture_Rising);
	TMM0_Start(ENABLE);
	
	while(1)
	{
		width = TMM_GetPulseWidth(TMM0,TMM_Channel_A);

		printf("P17/TMIOA pulse width  = %d fCLK\n", width);  /* expected value: msCnt */
	}
}




